package annas.graph;

import java.util.Map;
import java.util.TreeMap;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class DisjointSet<T> {

	private Map<T, T> Parent = new TreeMap<T, T>();
	
	private final Lock lock = new ReentrantLock();

	public void makeSet(T x) {
		lock.lock();
		try {
			Parent.put(x, x);
		} finally {
			lock.unlock();
		}
	}

	public void union(T x, T y) {
		lock.lock();
		try {
			for (T z : Parent.keySet()) {
				if (findSet(z).equals(findSet(y))) {
					Parent.put(z, findSet(x));
				}
			}
		} finally {
			lock.unlock();
		}
	}

	public T findSet(T x) {
		if (Parent.get(x).equals(x)) {
			return x;
		} else {
			return findSet(Parent.get(x));
		}
	}

	public Map<T, T> getMap() {
		return Parent;
	}

}