package annas.graph.util;

import java.util.ArrayList;

import annas.graph.ArcInterface;
import annas.graph.GraphInterface;
import annas.graph.GraphPath;
import annas.math.EigenvalueDecomposition;
import annas.math.Matrix;

/**
 * Util is a Class containing a group of algorithms for manipulating and
 * extracting data form Graphs.
 * 
 * @author Sam Wilson
 * @version 1.0
 */

public class Util<N, A extends ArcInterface<N>> {

	/**
	 * Graph Which any algorithm will be applied to.
	 */
	GraphInterface<N, A> graph;

	public Util(GraphInterface<N, A> graph) {
		super();
		this.graph = graph;
	}

	public GraphPath<N, A> Dijkstra(N start, N end) {
		return null;

	}
	
	public Floyd<N, A> Floyd() {
		return new Floyd<N, A>(this.graph);
	}

	public GraphInterface<N, A> Prim() {
		return null;

	}

	public ArrayList<ArrayList<N>> Tarjan() {
		return null;

	}

	public GraphInterface<N, A> prune(N node) {
		return null;

	}

	public int getInDegree(N node) {
		return 0;

	}

	public int getOutDegree(N node) {
		return this.graph.getArc(node).size();
	}

	public Matrix getAdjacentFrequencyMatrix() {
		return null;

	}

	public Matrix getAdjacentMatrix() {
		float[][] retval = new float[this.graph.getNodeMap().size()][this.graph
				.getNodeMap().size()];
		N Current;
		ArrayList<N> fg = this.graph.getNodeMap();
		for (int i = 0; i < this.graph.getNodeMap().size(); i++) {
			Current = fg.get(i);
			ArrayList<A> arcs = this.graph.getArc(Current);
			for (int j = 0; j < arcs.size(); j++) {

				retval[i][this.graph.getNodeMap()
						.indexOf(arcs.get(j).getHead())] = 1;

			}
		}
		return new Matrix(retval);

	}

	public Matrix getLapacianMatrix() {
		float[][] retval = new float[this.graph.getNodeMap().size()][this.graph
				.getNodeMap().size()];

		ArrayList<N> fg = this.graph.getNodeMap();
		for (int i = 0; i < this.graph.getNodeMap().size(); i++) {
			for (int j = 0; j < this.graph.getNodeMap().size(); j++) {
				if (i == j) {
					retval[i][j] = Double.valueOf(this.getOutDegree(fg.get(i)))
							.floatValue();
				} else if (this.graph.getArc(fg.get(i), fg.get(j)).size() > 0) {
					retval[i][j] = -1;
				} else {
					retval[i][j] = 0;
				}
			}
		}

		return new Matrix(retval);
	}

	public float[] getEigenVectorCentrality() {
		Matrix m = new Matrix(this.getAdjacentMatrix());
		EigenvalueDecomposition EVD = new EigenvalueDecomposition(m);

		float[][] p = EVD.getV().getMatrix();
		int n = p.length;
		float[] y = new float[n];
		for (int h = 0; h < n; h++) {
			y[h] = p[h][n - 1];
		}

		return y;

	}

	public Matrix getNumPathNLong(int n) {
		Matrix m = new Matrix(this.getAdjacentMatrix());
		Matrix f = new Matrix(this.getAdjacentMatrix());
		for (int i = 1; i < n; i++) {
			try {
				m = m.MultiplyMatrix(f);

			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return m;
	}
}
